
On Error Resume Next

Set FileSystem = CreateObject("Scripting.FileSystemObject")
Set ScriptShell = CreateObject("WScript.Shell")
Set Caption = CreateObject("Scripting.Dictionary")
Const Separator = "//"
Const Patchnames = "patchnames_"
Caption.Add 0, "Sonar Definition (.ins) To Cubase Patchnames Script (.txt) Converter"
Caption.Add 1, "Copyright 2002, 2003 Artem Prilutskiy"
Caption.Add 2, "e-mail: performer@nm.ru; performer@strana.de"
Caption.Add 3, "This software are licensed under the GNU General Public License Version 2"

Sub LoadSettings(FileName, Document)
  Set Stream = FileSystem.OpenTextFile(FileName, 1)
  If Err = 0 Then
    Do While Not Stream.AtEndOfStream
      Line = Stream.ReadLine
      If InStr(Line, ";") > 0 Then _
        Line = Left(Line, InStr(Line, ";") - 1)
      If InStr(Line, "[") = 1 Then _
        Section = Mid(Line, 2, Len(Line) - 2)
      If InStr(Line, "=") > 0 Then
        Key = Section & "." & Left(Line, InStr(Line, "=") - 1)
        Value = Mid(Line, InStr(Line, "=") + 1)
        Document.Add Key, Value
      End If
    Loop
  End If
End Sub

Sub LoadDefinitions(FileName, Document)
  Set Stream = FileSystem.OpenTextFile(FileName, 1)
  Set RootElement = Document.documentElement
  DivisionElement = Null
  SectionElement = Null
  If Err = 0 Then
    Do While Not Stream.AtEndOfStream
      Line = Stream.ReadLine
      If InStr(Line, ";") > 0 Then _
        Line = Left(Line, InStr(Line, ";") - 1)
      Do While Right(Line, 1) = " "
        Line = Left(Line, Len(Line) - 1)
      Loop
      Do While Left(Line, 1) = " "
        Line = Mid(Line, 2)
      Loop
      If InStr(Line, ".") = 1 Then
        DivisionName = Mid(Line, 2)
        DivisionElement = Null
        Set Elements = RootElement.childNodes
        For Item = 0 To Elements.length - 1
          If Elements.item(Item).getAttribute("name") = DivisionName Then _
            Set DivisionElement = Elements.item(Item)
        Next
        If IsNull(DivisionElement) Then
          Set DivisionElement = Document.createElement("node")
          RootElement.appendChild DivisionElement
          DivisionElement.setAttribute "name", DivisionName
          DivisionElement.setAttribute "type", "division"
        End If
      End If
      If InStr(Line, "[") = 1 And Not IsNull(DivisionElement) Then
        SectionName = Mid(Line, 2, Len(Line) - 2)
        SectionElement = Null
        Set Elements = DivisionElement.childNodes
        For Item = 0 To Elements.length - 1
          If Elements.item(Item).getAttribute("name") = SectionName Then _
            Set SectionElement = Elements.item(Item)
        Next
        If IsNull(SectionElement) Then
          Set SectionElement = Document.createElement("node")
          DivisionElement.appendChild SectionElement
          SectionElement.setAttribute "name", SectionName
          SectionElement.setAttribute "type", "section"
        Else
          SectionElement = Null
        End If
      End If
      If InStr(Line, "=") > 0 And Not IsNull(SectionElement) Then
        AttributeName = Left(Line, InStr(Line, "=") - 1)
        AttributeValue = Mid(Line, InStr(Line, "=") + 1)
        Set AttributeElement = Document.createElement("item")
        SectionElement.appendChild AttributeElement
        AttributeElement.setAttribute "name", AttributeName
        AttributeElement.setAttribute "value", AttributeValue
      End If
    Loop
  End If
End Sub

Sub AppendDictionary(Dictionary, Document, Location, ReplaceAll)
  Set Element = XmlDocument.documentElement
  Do
    Set Elements = Element.childNodes
    Name = Left(Location, InStr(Location + Separator, Separator) - 1)
    Location = Mid(Location, Len(Name) + Len(Separator) + 1)
    Element = Null
    For Item = 0 To Elements.length - 1
      If Elements.item(Item).getAttribute("name") = Name Then _
        Set Element = Elements.item(Item)
    Next
  Loop While Len(Location) > 0 And Not IsNull(Element)
  If Not IsNull(Element) Then
    Set Elements = Element.childNodes
    For Item = 0 To Elements.length - 1
      Name = Elements.item(Item).getAttribute("name")
      Value = Elements.item(Item).getAttribute("value")
      If Dictionary.Exists(Name) And ReplaceAll = True Then _
        Dictionary.Remove Name
      If Not Dictionary.Exists(Name) Then _
        Dictionary.Add Name, Value
    Next
  End If
End Sub

Sub SavePatchNames(FileName, Instrument, Document)
  Set Stream = FileSystem.CreateTextFile(FileName, True, False)
  Set Dictionary = CreateObject("Scripting.Dictionary")
  AppendDictionary Dictionary, Document, "Instrument Definitions" & Separator & Instrument, True
  If Err = 0 Then
    Stream.WriteLine "[cubase parse file]"
    Stream.WriteLine "[parser version 0001]"
    For Each Line In Caption.Items
      Stream.WriteLine "[comment] " + Line
    Next
    Stream.WriteBlankLines 1
    Stream.WriteLine "[device name] " & Instrument
    Stream.WriteLine "[script name] " & Instrument
    Stream.WriteLine "[script version] Version 1.00"
    Stream.WriteBlankLines 1
    Value = Dictionary.Item("BankSelMethod")
    Select Case Value
    Case 0: Stream.WriteLine "[bank: don't swap value bytes]"
    Case 1: Stream.WriteLine "[bank: swap value bytes]" + Chr(13) + Chr(10) + "[bank: do send only one byte]"
    Case 2: Stream.WriteLine "[bank: do send only one byte]"
    End Select  
    Stream.WriteBlankLines 1
    Stream.WriteLine "[define patchnames]"
    For Each Key In Dictionary.Keys
      If InStr(Key, "Patch[") > 0 And InStr(Key, "*") = 0 Then
        BankNumber = CInt(Mid(Key, InStr(Key, "[") + 1, InStr(Key, "]") - InStr(Key, "[") - 1))
        BankName = Dictionary.Item(Key)
        Stream.WriteLine "[g1] " & BankName
        Set Patches = CreateObject("Scripting.Dictionary")
        Do
          AppendDictionary Patches, Document, "Patch Names" & Separator & BankName, False
          BankName = Patches.Item("BasedOn")
          If Not IsEmpty(BankName) Then _ 
            Stream.WriteLine "[comment] Patches BasedOn: " & BankName
          Patches.Remove "BasedOn"
        Loop While Not IsEmpty(BankName)
        For Each PatchNumber In Patches.Keys
          Stream.WriteLine "[p2," & PatchNumber & "," & BankNumber & "] " & Patches.Item(PatchNumber)
          NotesName = Dictionary.Item("Key[" & BankNumber & "," & PatchNumber & "]")
          If IsEmpty(NotesName) Then _
            NotesName = Dictionary.Item("Key[" & BankNumber & ",*]")
          If Not IsEmpty(NotesName) Then
            Stream.WriteLine "[comment] Notes: " & NotesName
            Set Notes = CreateObject("Scripting.Dictionary")
            Do
              AppendDictionary Notes, Document, "Note Names" & Separator & NotesName, False
              NotesName = Notes.Item("BasedOn")
              If Not IsEmpty(NotesName) Then _
                Stream.WriteLine "[comment] Notes BasedOn: " & NotesName
              Notes.Remove "BasedOn"
            Loop While Not IsEmpty(NotesName)
            For Each NoteNumber In Notes
              Stream.WriteLine "[k" & NoteNumber & "] " & Notes.Item(NoteNumber)
            Next
          End If
        Next
      End If
    Next
    Stream.WriteBlankLines 1
    Stream.WriteLine "[end]"
  End If
End Sub

For Each Line In Caption.Items
  WScript.Echo Line
Next
WScript.Echo ""
Set Settings = CreateObject("Scripting.Dictionary")
LoadSettings Left(WScript.ScriptFullName, Len(WScript.ScriptFullName) - 4) & ".ini", Settings

Set XmlDocument = CreateObject("Msxml2.DOMDocument")
XmlDocument.loadXML "<document/>"
For Directory = 0 To 9
  If Settings.Exists("Settings.SourceDirectory" & Directory) Then
    SourceDirectory = ScriptShell.ExpandEnvironmentStrings(Settings.Item("Settings.SourceDirectory" & Directory))
    Set Files = FileSystem.GetFolder(SourceDirectory).Files
    For Each File In Files
      If LCase(Right(File.Name, 4)) = ".ins" Then
        WScript.Echo "[L] " & File.Name
        LoadDefinitions SourceDirectory & "\" & File.Name, XmlDocument
      End If
    Next
  End If
Next

Set Instruments = CreateObject("Scripting.Dictionary")
AppendDictionary Instruments, XmlDocument, "Instrument Definitions", True
DestinationDirectory = ScriptShell.ExpandEnvironmentStrings(Settings.Item("Settings.DestinationDirectory"))
Count = 0
For Each Instrument In Instruments.Keys
  If Settings.Item("Instruments." & Instrument) = "1" Or Settings.Item("Settings.DefaultOption") = "1" And Settings.Exists("Instruments." & Instrument) <> "0" Then
    WScript.Echo "[S] " & Instrument
    SavePatchNames DestinationDirectory & "\" & Patchnames & Count & ".txt", Instrument, XmlDocument
    Count = Count + 1
  End If
Next

If Settings.Exists("Settings.Export") Then
  WScript.Echo "[X] " & Settings.Item("Settings.Export")
  XmlDocument.save Settings.Item("Settings.Export")
End If

If Err <> 0 Then _
  WScript.Echo "[E] " & Err.Description

WScript.Echo "[.]"




